# virtu-crud
Virtuba server-side crud command router for remote encrypted fileserver

## Installations:
Clone the repository 
````
npm install virtu-crud
````

## Usage
````
	
var crud = require('virtu-crud'),
	// hash any text on the fly... 
	file_md5 = crud.toHash("test"),
	user_hash = crud.toHash("username"),
	// map should be a json file encrypted inside the user browser before being sent to webserver
	user_map = {"map": map}

// or asyncrononous with callback ... 
crud.toHash_async("test". function(err, hash){
	if (err){throw err}
	console.log(hash)

// add some actions on the fly... 
crud.add.create("", file_md5)
crud.add.read(file_md5)
crud.add.update(hash, file_md5)
crud.add.destroy(hash)

// Then send it all to command server async
crud.send(user_hash, user_map, function(err){
    if (err){ console.log(err)}
    return true
})

}//end of crud.toHash_async
````
### Dependencies
````
    "js-md5": "",
    "aes256": "1.0.2",
    "chai": ""
````
