// Author: Jean-Philippe Beaudet @ S3R3NITY Technology 
//
// Virtuba crud router
// CRUD
//
// Version : 1.1.6
// Copyrigths S3R3NITY Technologies.
//
//========================================================

// dependencies
var aes256 = require('aes256')
var config = require("./config.js");
var md5 = require('js-md5');
var fs = require('fs')
// globals
var TMP_FILE = config.tmp_file
var PASSPHRASE = config.passphrase

// manage keys
var pubkey, virtuba_pubkey, virtuba_privkey;
fs.readFile('./key.pub', (err, data) => {
	if (err) throw err;
	pubkey =data
});
var virtuba_pubkey ;
fs.readFile('./keys/virtuba.pub', (err, data) => {
	if (err) throw err;
	virtuba_pubkey =data
});
var virtuba_privkey ;
fs.readFile('./keys/virtuba.priv', (err, data) => {
	if (err) throw err;
	virtuba_privkey =data
});

// private encrypting helper method
function encrypt(path, finalpath, callback){
	var err =null
	//gpg --batch --passphrase "your_secret_pgpkey_passphrase"  --output=./var/tmp/d41d8cd98f00b204e9800998ecf8427e.gpg -u "virtuba_webserver" -r "philtuba" --encrypt ./var/tmp/d41d8cd98f00b204e9800998ecf8427e.json
	const exec = require('child_process').exec;
	exec('gpg --batch --no-tty --passphrase '+config.passphrase+' --output='+finalpath+' -u virtuba_webserver -r philtuba --encrypt '+path, function(error, stdout, stderr){
	if (error) {
		console.error(`exec error: ${error}`);
		err =error
	}
	console.log(`stdout: ${stdout}`);
	console.log(`stderr: ${stderr}`); 
	});
	callback(err)
	
}
function write(jsonpath, msg, options, callback){
	fs.writeFileSync(jsonpath, JSON.stringify(msg), options)
	callback() 
}

// process the json qith the queu msg method
function process_json(msg, username_hash, callback){
	var options = {
		encoding: "ASCII"
	}
	// copy json to target tmp file
	var jsonpath = TMP_FILE+'/'+username_hash+'.json',
	finalpath = TMP_FILE+'/'+username_hash+'.gpg'
	write(jsonpath, msg, options, function(){
		encrypt(jsonpath, finalpath, function(err){
		callback()
		});
	})
}

// Session object
///////////////////////////////////////////////////
// multi-user sessions object prototypes

// create session 
var session = function() {
	this._id = md5(Math.floor(Math.random())),
	this.users = []
	return this;
}
// command file q constructor
var q = function(username_hash) {
	this.username_hash = username_hash,
	this.tmpfolder = TMP_FILE,
	this.actions ={}
	this.actions.create = []
	this.actions.read = []
	this.actions.update = []
	this.actions.destroy = []
}
// add a new user to sessions
session.prototype.addUser = function(username_hash) {
	var queue = new q(username_hash)
	this.users.push(queue)
	//return this;
};
// save the user in the session with its current queue
session.prototype.saveUser = function(queue) {
	var index=null;
	for (i = 0; i < this.users.length; i++) { 
		if(this.users[i].username_hash === queue.q.username_hash){
			index = i
		}
	}
	if(index !=null){
		this.users[index]= queue.q
	}else{
		this.users.push(queue.q)
	}
	return this
};
// save sessions to file
session.prototype.user = function() {
	return this.users
}
// save sessions to file
session.prototype.save = function(options) {
	var opt = options || {}
	var path, name;
	opt.path? path=option.path:path=TMP_FILE
	opt.name? name=option.name:name=this._id
	fs.writeFileSync(path+"/"+name+'.save', JSON.stringify(this))
	return
};
// session query logic read
session.prototype.read = function(options) {
	var username_hash, all, err= {message:"bad parameters"}
	if(!option){ return this}
	if(option.username_hash){ return this.users[this.users.indexOf(username_hash)]}
	
}
// queue system
//////////////////////////////////////////////////////////
session.prototype.queue = function(username_hash) {
	var index=null;
	for (i = 0; i < this.users.length; i++) { 
		if(this.users[i].username_hash === username_hash){
			index = i
		}
	}
	if(index!=null && this.users[index] != null){
		var user = this.users[index]
		this.users.splice(index,1); 
		return new queue(user)
	}else{
		var qq = new queue(new q(username_hash))
		this.users.push(qq)
		return qq
	}
}
//queue constructor
var queue = function(q){
	this.q = q
	//return this;
}
// CRUD prototypes
queue.prototype.create = function(old_name, new_name){
	this.q.actions.create.push([old_name, new_name])
	return this;
}
queue.prototype.read = function(target){
	this.q.actions.read.push(target)
	return this;
}
queue.prototype.update = function(old_name, new_name){
	this.q.actions.update.push([old_name, new_name])
	return this;
}
queue.prototype.destroy = function(target){
	this.q.actions.destroy.push(target)
	return this;
}
// send method as prototype that will return itself refreshed and usable again
queue.prototype.send = function(map_to_push){
	// add user encrypted map.json
	this.map = TMP_FILE+'/'+this.q.username_hash+'.txt'
	var self = this.q
	// process json, write a file, encrypt it with gpg and then deposit at TMP_FILE(config.js) location
	process_json(self, self.username_hash, function(){
		fs.writeFileSync(TMP_FILE+'/'+self.username_hash+'.txt', map_to_push)
		self =  new q(self.username_hash)
		return this;
		})
}
// option to refrsh the actual user queue on the fly
queue.prototype.refresh = function(){
	this.q =  new q(this.q.username_hash)
	return this
}
//  --- OLD VERSION --- old command file queue (retro compactibility)
var queue1 = {
	username_hash: null,
	tmpfolder : TMP_FILE,
	actions:{
		create : [],
		read: [],
		update: [],
		destroy: []
	}
}

// Main Module
/////////////////////////////////////////////
module.exports = {
	// start a new session
	session: function(){return new session()},
	// any text to md5 async
	toHash_async : function(msg, callback){
		md5(msg);
		var hash = md5.create();
		callback(null, hash.hex());
		}, 
	// any text to md5
	toHash : function(msg){
		md5(msg);
		var hash = md5.create();
		return(md5(msg));
		}, 
	// --- OLD VERSION --- crud function
		// add action in the queue
		add : {
			// create (old[or empty], new)
			create : function(old_name, new_name){
				 queue1.actions.create.push([old_name, new_name])
				 //console.log(queue)
				 return queue1
			},
			// read (target)
			read : function(target){
				queue1.actions.read.push(target)
				return queue1
			},
			// update (old, new)
			update : function(old_name, new_name){
				queue1.actions.update.push([old_name, new_name])
				return queue1
			},
			// delete (target)
			destroy : function(target){
				queue1.actions.destroy.push(target)
				return queue1
			},
		},
		//  --- OLD VERSION ---  remove all actions from the queue 
		refresh : function(callback){
			queue1 = {
				username_hash: null,
				tmpfolder : TMP_FILE,
				actions:{
					create : [],
					read: [],
					update: [],
					destroy: []
				}
			}
			callback(queue1)
		},
	//  --- OLD VERSION ---  send command file(map_to_push, callback(err, map, data))
		send : function(username_hash, map_to_push, callback){
			// complete json
			queue1.username_hash = username_hash
			queue1.map = TMP_FILE+'/'+username_hash+'.txt'
			// encrypt json
			process_json(queue1, username_hash, function(){
				fs.writeFileSync(TMP_FILE+'/'+username_hash+'.txt', map_to_push)
			})
			this.refresh(function(){
				callback(null)
			})
		}
}
